/*
Setting Input & PMP registers for MA12070 at startup and then controling volume

Patrick Quah 2023

At startup, MA12070 is set to i2s input and PMP2
MA12070 only has volatile memory (no eeprom) so this needs to be done everytime it is turned on.
It's recommended to draw 5V for the ATTiny/Arduino from the MA12070 supply so registers are written every time the MA12070 is turned on

Connections:

MA12070  AtTiny  Nano/Uno
SDA       PB0     D18
SCL       PB2     D19

Pullup resistors need to be attached between +5v and SDA/SCL pins. 
I'm using 4k7, but anything around that will work

This has been tested on the ATTiny85 and Arduino Nano/Uno

<<Could not get this to work>> The volume is controlled via sampling the wiper voltage of a potentiometer connected to pin A1
Any changes will be written to register 0x40 which contains an 8bit word which corresponds
to the volume level 0-255
*/

#include<Wire.h>
int led=1; //LED for Uno = 13, Attiny = 1

/*
//For volume control - not working

int VOLUME = A1;
int volume = 0;
int volume_curr = 0;
float vdiff = 0;
int hys = 2;
*/

void setup() 
{
  Wire.begin();

  //Change PMP from 0 (default) to 2
  Wire.beginTransmission(0x20); // 0x20 = default MA12070 I2C address
  Wire.write (0x1D); // 0x1D = PMP Register
  Wire.write (0x02); //Set to PMP2
  Wire.endTransmission();

  //Change input from i2s Left Justified (default) to standard i2s
  Wire.beginTransmission(0x20);// 0x20 = default MA12070 I2C address
  Wire.write (0x35); // 0x35 = data input config register
  Wire.write (0x00); //Set input to i2s
  Wire.endTransmission();

  //double blink led to confirm code uploaded
  digitalWrite (led, HIGH);
  delay(500);
  digitalWrite (led, LOW);
  delay(500);
  digitalWrite (led, HIGH);
  delay(500);
  digitalWrite (led, LOW);

}

void loop() 
{
/*
//Volume control - not working

  volume = analogRead(VOLUME);
  vdiff = abs (volume - volume_curr);
  if (vdiff > hys)
    {
      volume_curr = volume;
      change_volume();
  }
}

void change_volume ()
{
  byte eightbitvol = volume/4; 
  Wire.beginTransmission(0x20);
  Wire.write (0x40);
  Wire.write (eightbitvol);
  Wire.endTransmission();
*/
}
